############ TCL FILE ######################################
#
# System:  ""
# Machine: "......"
# Type: MILL
# Russia,
# Rodionova
##############################################################################
# 
#          7 ,....,  
#   2,5     
#
#
##############################################################################

  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]

  if { ![info exists mom_sys_post_initialized] } {

     source ${cam_post_dir}ugpost_base.tcl

     proc MOM_before_each_add_var {} {}
     proc MOM_before_each_event {} {}

#     set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]
#     source ${cam_debug_dir}mom_review.tcl

     MOM_set_debug_mode OFF


   ####  Listing File variables
     set mom_sys_list_output                       "ON"
     set mom_sys_header_output                     "OFF"
     set mom_sys_list_file_rows                    "120"
     set mom_sys_list_file_columns                 "80"
     set mom_sys_warning_output                    "OFF"
     set mom_sys_group_output                      "OFF"
     set mom_sys_list_file_suffix                  "lpt"
     set mom_sys_output_file_suffix                "ptp"
     set mom_sys_commentary_output                 "ON"
     set mom_sys_commentary_list                   "x y z feed speed"

     set mom_sys_control_out                       " ; "
     set mom_sys_control_in                        " "

     set mom_sys_post_initialized 1
  }


#=============================================================
#    UGPost  .
#The following file consists of default values set for G & M codes
#=============================================================

#---------------- M code declaration

  set mom_sys_program_stop_code                 0
  set mom_sys_optional_stop_code                1
  set mom_sys_end_of_program_code               2

  set mom_sys_spindle_direction_code(NONE)      3
  set mom_sys_spindle_direction_code(CLW)       3
  set mom_sys_spindle_direction_code(CCLW)      4
  set mom_sys_spindle_direction_code(OFF)       5

  set mom_sys_tool_change_code                  6

  set mom_sys_coolant_code(ON)                  "8"
  set mom_sys_coolant_code(FLOOD)               "8"
  set mom_sys_coolant_code(MIST)                "7"
  set mom_sys_coolant_code(THRU)                "26"
  set mom_sys_coolant_code(TAP)                 "27"
  set mom_sys_coolant_code(OFF)                 "9"

  set mom_sys_program_end_code                  30

#---------------- G code declaration

  set mom_sys_rapid_code                     0
  set mom_sys_linear_code                    1
  set mom_sys_circle_code(CLW)               2
  set mom_sys_circle_code(CCLW)              3

  set mom_sys_delay_code(REVOLUTIONS)        4
  set mom_sys_delay_code(SECONDS)            4
  set mom_sys_delay_code(SLOWDN)            "9"

  set mom_sys_cutcom_plane_code(XY)             "17"
  set mom_sys_cutcom_plane_code(ZX)             "18"
  set mom_sys_cutcom_plane_code(XZ)             "18"
  set mom_sys_cutcom_plane_code(YZ)             "19"
  set mom_sys_cutcom_plane_code(ZY)             "19"

  set mom_sys_inch_code                      70
  set mom_sys_metric_code                    71

  set mom_sys_reset_code		     "79"

  set mom_sys_cutcom_code(OFF)                  "40"
  set mom_sys_cutcom_code(LEFT)                 "41"
  set mom_sys_cutcom_code(RIGHT)                "42"
  set mom_sys_adjust_code                       "43"
  set mom_sys_adjust_code_minus                 "44"
  set mom_sys_adjust_cancel_code                "49"
  set mom_sys_unit_code(IN)                     "70"
  set mom_sys_unit_code(MM)                     "71"

  set mom_sys_spindle_max_rpm_code           50
  set mom_sys_wcs_change_code                0

  set mom_sys_mirror_image_on                68
  set mom_sys_mirror_image_off               69

#   
  set mom_sys_cycle_off                      80 ; #   
  set mom_sys_cycle_drill_code               81 ; # 
  set mom_sys_cycle_drill_dwell_code         82 ; #    
  set mom_sys_cycle_drill_deep_code          83 ; #   
  set mom_sys_cycle_breakchip_code           83 ; #   
  set mom_sys_cycle_tap_right_code           84 ; #    
  set mom_sys_cycle_tap_left_code            88 ; #    
  set mom_sys_cycle_bore_code                85 ; # 
  set mom_sys_cycle_bore_drag_code           85 ; # 
  set mom_sys_cycle_bore_no_drag_code        82 ; #    
  set mom_sys_cycle_bore_back_code 	     87 ; #    
  set mom_sys_cycle_bore_dwell_code          89 ; #    
  set mom_sys_lathe_thread_advance_type(1)  "33"
  set mom_sys_lathe_thread_advance_type(2)  "33"
  set mom_sys_lathe_thread_advance_type(3)  "33"
;#
  set mom_sys_feed_rate_mode_code(MMPM)     "94"
  set mom_sys_feed_rate_mode_code(MMPR)     "94"
  set mom_sys_feed_rate_mode_code(FRN)      "94"
  set mom_sys_spindle_mode_code(SFM)        "97"
  set mom_sys_spindle_mode_code(RPM)        "97"
  set mom_sys_spindle_mode_code(SFM)        "97"
#
  set mom_sys_corner_code(OFF)		"38"
  set mom_sys_corner_code(ON)		"39"
#
  set mom_sys_feedrate_code(IPM)             94
  set mom_sys_feedrate_code(IPR)             94

  set mom_sys_spindle_ranges                    "0"
  set mom_sys_rewind_stop_code                  "%"
  set mom_sys_home_pos(0)                       "0"
  set mom_sys_home_pos(1)                       "0"
  set mom_sys_home_pos(2)                       "0"
  set mom_sys_zero                              "0"
  set mom_sys_opskip_block_leader               "/"
  set mom_sys_seqnum_start                      "1"
  set mom_sys_seqnum_incr                       "1"
  set mom_sys_seqnum_freq                       "1"
  set mom_sys_seqnum_max                        "999999"
  set mom_sys_leader(N)                         "N"
  set mom_sys_leader(X)                         "X"
  set mom_sys_leader(Y)                         "Y"
  set mom_sys_leader(Z)                         "Z"

#_______________________________________________________________________________
#
# Kinematic Variable Declaration
#_______________________________________________________________________________
  set mom_kin_coordinate_type                   "CARTESIAN"
  set mom_kin_read_ahead_next_motion            "F" ; # TRUE
  set mom_kin_arc_output_mode                   "FULL_CIRCLE" ; # QUADRANT ; LINEAR ; FULL_CIRCLE
  set mom_kin_arc_valid_plane                   "XY" ;  #XY  XZ XYZ  ANY
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_flush_time                        "2.0"
  set mom_kin_linearization_flag                "FALSE"
  set mom_kin_linearization_tol                 "0.01"
  set mom_kin_machine_resolution                "0.001"
  set mom_kin_machine_type                      "3_axis_mill"
  set mom_kin_max_arc_radius                    "99999.999"
  set mom_kin_max_dpm                           "10"
  set mom_kin_max_fpm                           "3000" ; # 1500
  set mom_kin_max_fpr                           "100"
  set mom_kin_max_frn                           "100"
  set mom_kin_min_arc_length                    "0.025"
  set mom_kin_min_arc_radius                    "0.016"
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.01"
  set mom_kin_min_fpr                           "0.01"
  set mom_kin_min_frn                           "0.01"
  set mom_kin_output_unit                       "MM"
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_pivot_guage_offset                ""
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "4800"
  set mom_kin_tool_change_time                  "60.0"
  set mom_kin_x_axis_limit                      "4000"
  set mom_kin_y_axis_limit                      "700"
  set mom_kin_z_axis_limit                      "450"


if [llength [info commands MOM_SYS_do_template] ] {
   if [llength [info commands MOM_do_template] ] {
      rename MOM_do_template ""
   }
   rename MOM_SYS_do_template MOM_do_template
}


###################################################################################

proc MOM_from_move {} {
#=============================================================
# This procedure is called for a FROM statement
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev  mom_motion_type mom_kin_max_fpm
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
  MOM_do_template from CREATE
}

proc MOM_gohome_move {} {
#=============================================================
# This procedure is called for a GOHOME move
#=============================================================
  MOM_do_template gohome
}


proc MOM_start_of_program {} {
#=============================================================
# This procedure is executed at the very begining of the program.
# It gets called before any command is read from the task file.
#=============================================================
  global mom_logname mom_date is_from
  global mom_coolant_status mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register
  global mom_wire_cutcom_status

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED
    set mom_wire_cutcom_status  UNDEFINED

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    set is_from ""

    catch { OPEN_files } ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing



  global mom_sys_post_initialized
  if { $mom_sys_post_initialized > 1 } { return }


#************
uplevel #0 {


#=============================================================
proc MOM_sync {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_handle_sync_event] ] {
    PB_CMD_kin_handle_sync_event
  }
}


#=============================================================
proc MOM_set_csys {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_set_csys] ] {
    PB_CMD_kin_set_csys
  }
}


#=============================================================
proc MOM_msys {} {
#=============================================================
}


##=============================================================
#proc MOM_end_of_program { } {
##=============================================================
#   MOM_do_template end_of_program
#   MOM_set_seq_off
#   MOM_do_template rewind_stop_code
#
##**** The following procedure lists the tool list with time in commentary data
#   LIST_FILE_TRAILER
#
##**** The following procedure closes the warning and listing files
#   CLOSE_files
#}


  incr mom_sys_post_initialized


} ;# uplevel
#***********

  catch { PB_slowdn_load }
  MOM_suppress off G_slowdn

}


proc MOM_end_of_program {} {
#=============================================================
# This procedure is executed at the end of the program after all
# the paths are traversed.
#=============================================================
  global mom_warning_info

  global mom_output_mode
  set mom_output_mode  "ABSOLUTE" ;   # "ABSOLUTE", "INCREMENTAL"
  MOM_set_modes

  MOM_do_template  spindle_coolant_off

# global mom_tool_number
# MOM_output_literal "G79Z0T$mom_tool_number.0M6"
# MOM_output_literal "T$mom_tool_number.0M6"
# MOM_output_literal "D0"
  MOM_output_literal "(UAO,0)"
  MOM_output_literal "G0 G90 X0 Y0"
###############################################
#####     - 
#################################################
 global mom_operation_type mom_machine_time
 if {$mom_operation_type!="Point to Point" } {
 	     
 	  if  {$mom_machine_time <10.0} {   set mom_machine_time   [ expr $mom_machine_time * 1.1 ] }
 	  if  {$mom_machine_time >=10.0 && $mom_machine_time <20.0} {   set mom_machine_time   [ expr $mom_machine_time * 1.11 ] }
	  if  {$mom_machine_time >=20.0} {   set mom_machine_time   [ expr $mom_machine_time * 1.15 ] }
 	}
 	
#########################################################

  global mom_machine_time
  set str0 "[format "%.2f" $mom_machine_time ] min"
  set str1 "    =$str0"
  set str2 "" ; 
  if [llength [info commands outTime] ] {
    set str2 [ outTime $mom_machine_time ]
  }  
  MOM_output_to_listing_device "$str1 $str2"  ;
  MOM_set_seq_off
  MOM_output_literal " ; TIME=$str0 $str2"
  MOM_set_seq_on

  MOM_do_template end_of_program

  LIST_FILE_TRAILER ; #---- The following procedure lists the tool list with time in commentary data

  CLOSE_files ;#---- The following procedure closes the warning and listing files

}


#=============================================================
proc PB_start_info { } {
#=============================================================
  set str "\n   '' (2.5x-3x)"
  MOM_output_to_listing_device $str

  set str "\n :\n"
  append str "\tG00 -   \n"
  append str "\tG17 -       XY\n"
  append str "\tG27 -         ( )\n"
  append str "\tG38 -    >180-     (.  G41|G42)\n"
  append str "\tG40 -    \n"
  append str "\tG71 -    \n"
  append str "\tG80 -   \n"
  append str "\tG90 -  \n"
  append str "\tG94 -    /\n"
  append str "\tG97 -     /\n"
  append str "\tG98 -     Z-    G81..G89\n"
  MOM_output_to_listing_device $str
}

#=============================================================
proc PB_start_of_program { } {
#=============================================================
  global mom_output_file_basename
  global mom_warning_info
  global mom_logname mom_date mom_machine_name  mom_part_name

#------- These are to be obtained for the user before Postprocessing
  catch { PB_start_info }

   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }

  PB_CMD_init_turbo_output

  set strname "" ;
  if [llength [info commands PB_part_name_ex] ] {
   	        set strname [ PB_part_name_ex ]
   	        set strname [ MOM_string_toupper $strname ]
  }

  set strmaterial "" ;
  if [llength [info commands PB_part_material] ] {
    set strmaterial [ PB_part_material ]
  }

  MOM_set_seq_off
  MOM_output_literal "; Part: $strname" ;
#  MOM_output_literal "; Material: $strmaterial" ;
  MOM_output_literal "; $mom_output_file_basename"
  MOM_output_literal "; $mom_logname, Date:$mom_date"
  MOM_output_literal "; MACHINE: ($mom_machine_name)" ; # FP-17SMN
  MOM_output_literal "   "
  MOM_do_template rewind_stop
  MOM_set_seq_on
  MOM_output_literal "(UAO,1)"
#
  catch { PB_slowdn_load }
  MOM_suppress off G_slowdn
}


#=============================================================
proc PB_CMD_machine_mode { } {
#=============================================================
  global mom_output_mode mom_arc_mode mom_prev_machine_mode mom_machine_mode mom_feed_set_mode
  set mom_output_mode     	"ABSOLUTE"
  set mom_prev_machine_mode  	"MILL"
  set mom_machine_mode 		"MILL"
  set mom_arc_mode     		"CIRCULAR"
  set mom_feed_set_mode 	"MMPM"
  #
}

#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  catch {PB_CMD_machine_mode} errMes ; MOM_log_message "$errMes" ;
}


#=============================================================
proc MOM_start_of_group {} {
#=============================================================
  global mom_sys_group_output mom_group_name group_level ptp_file_name
  global mom_sequence_number mom_sequence_increment mom_sequence_frequency
  global mom_sys_ptp_output pb_start_of_program_flag

    if {![hiset group_level]} {set group_level 0 ; return}

    if {[hiset mom_sys_group_output]} {if {$mom_sys_group_output == "OFF"} {set group_level 0 ; return}}

    if {[hiset group_level]} {incr group_level} else {set group_level 1}
    if {$group_level > 1} {return}

    SEQNO_RESET ; #<4133654>
    MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency

    if {[info exists ptp_file_name]} {
      MOM_close_output_file $ptp_file_name ; MOM_start_of_program
      if {$mom_sys_ptp_output == "ON"} {MOM_open_output_file $ptp_file_name }
    } else {
      MOM_start_of_program
    }

    PB_start_of_program ; set pb_start_of_program_flag 1
}


proc MOM_start_of_path {} {
#=============================================================
# This procedure is executed at the begining of each path in the task
# It gets called after all the general parameters of the path are loaded
# like the path name and the tool name.
#=============================================================
  global pb_start_of_program_flag
  if {$pb_start_of_program_flag == 0} {
	PB_start_of_program
     	set pb_start_of_program_flag 1

#-------------------------------------------------------
  global mom_update_post_cmds_from_tool
  if {[info exists mom_update_post_cmds_from_tool]} {
   if {$mom_update_post_cmds_from_tool==0} {

uplevel #0 {

#=============================================================
proc MOM_tool_change {} {
#=============================================================
}

#=============================================================
proc MOM_first_tool { } {
#=============================================================
}

#=============================================================
proc MOM_load_tool {} {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}

    } ; # uplevel
  } ; # if
 } ; # if
#-------------------------------------------------------


   }

  global mom_sys_in_operation
   set mom_sys_in_operation 1

  global first_linear_move ; set first_linear_move 0
   TOOL_SET MOM_start_of_path

   if [llength [info commands PB_CMD_kin_start_of_path] ] {
      PB_CMD_kin_start_of_path
   }

  MOM_force once G_motion F

  global mom_imported_path_status
  global mom_kin_arc_output_mode mom_operation_name mom_warning_info
  if {[info exists mom_imported_path_status]==1} {
     if {"YES"==[string toupper "$mom_imported_path_status"]} {
       set mom_warning_info "WARNING: =$mom_operation_name -   ( -   !)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set mom_kin_arc_output_mode  "QUADRANT"  ;   #QUADRANT  FULL_CIRCLE , LINEAR
       MOM_reload_kinematics
      }
   }

 global mom_operation_name
 MOM_set_seq_off
 MOM_output_literal "     "
 MOM_output_literal "; $mom_operation_name "
 MOM_set_seq_on

}


proc MOM_end_of_path {} {
#=============================================================
# This procedure is executed at the end of a path.
#=============================================================

   if [llength [info commands PB_CMD_kin_end_of_path] ] {
      PB_CMD_kin_end_of_path
   }

   global mom_sys_in_operation
   set mom_sys_in_operation 0
}


proc MOM_tool_change {} {
#=============================================================
# This procedure is executed at any time there is a tool change.
# It gets called after the tool change data is loaded like the tool number
# and the register numbers.
#=============================================================
  MOM_do_template spindle_off

  global mom_tool_change_type mom_manual_tool_change
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}

#=============================================================
proc MOM_load_tool {} {
#=============================================================
}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================
   PB_CMD_tool_change_force_addresses
   MOM_force Once  Z
   MOM_force Once T M
   catch { MOM_do_template tool_change CREATE }
   catch { MOM_do_template tool_change_next CREATE }
}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
   PB_CMD_tool_change_force_addresses
   MOM_do_template stop
}

#=============================================================
proc PB_CMD_tool_change_force_addresses { } {
#=============================================================
  MOM_force once G_adjust D X Y Z
}


############################################################################
proc MOM_initial_move {} {
#=============================================================
# This procedure is executed for the initial move of each operation.  It
# assumes the tool is moving from a safe position at rapid to the start of
# the operation.
#=============================================================
  global mom_warning_info
  global mom_spindle_rpm

  catch { COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET }

  if [llength [info commands PB_CMD_tool_info] ] {
   set line ""
   set line [ PB_CMD_tool_info ]
   if {"$line"!=""} {
     MOM_suppress ONCE N
     MOM_output_literal " ; $line" ;
   }
  }

  global mom_update_post_cmds_from_tool
  if {[info exists mom_update_post_cmds_from_tool]} {
    if {$mom_update_post_cmds_from_tool==1} {

        if {[info exists mom_spindle_rpm] != 0} {
           if {$mom_spindle_rpm != 0.0} {
	      MOM_spindle_rpm
           } else {
 	      set mom_warning_info "Warning: SPINDLE RPM IS 0"
 	      MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
        }

    }
   }

#   
  MOM_force once  G_motion X Y Z ; # F M_coolant
  MOM_do_template rapid_xy
  MOM_do_template rapid_z

#   global mom_motion_event  mom_motion_type
#   global mom_programmed_feed_rate  mom_feed_rate  mom_kin_rapid_feed_rate
#   if { [EQ_is_equal $mom_programmed_feed_rate 0.0] || [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate ] } {
#      MOM_rapid_move
#    } else {
#        if {$mom_motion_event == "rapid_move"} { MOM_rapid_move; return ;  }
#  	if {$mom_motion_type == "RAPID"} { MOM_rapid_move ; return ; }
#      MOM_linear_move
#   }

}


##########################################################################################

proc MOM_first_move {} {
#_______________________________________________________________________________
 # global mom_motion_event
 # global mom_coolant_mode  mom_coolant_status
 # if {[info exists mom_coolant_mode]} {  set mom_coolant_status $mom_coolant_mode  }
 # catch {MOM_$mom_motion_event}

  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
   catch {MOM_$mom_motion_event}

}


###############################################################################

########################
# Redefine FEEDRATE_SET -     MMPM ;   - 
########################
if [llength [info commands ugpost_FEEDRATE_SET] ] {
   rename ugpost_FEEDRATE_SET ""
}

if [llength [info commands FEEDRATE_SET] ] {
   rename FEEDRATE_SET ugpost_FEEDRATE_SET
} else {
   proc ugpost_FEEDRATE_SET {} {}
}


#=============================================================
proc FEEDRATE_SET {} {
#=============================================================
   if [llength [info commands PB_CMD_kin_feedrate_set] ] {
      PB_CMD_kin_feedrate_set
   } else {
      ugpost_FEEDRATE_SET
   }
}

proc ASK_FEEDRATE_FPM {} {
#_______________________________________________________________________________
# returns feed rate IN or MM per min
#_______________________________________________________________________________
  global mom_feed_rate

  if {[hiset mom_feed_rate]} {
    global mom_kin_rapid_feed_rate
    if {$mom_feed_rate>=$mom_kin_rapid_feed_rate} {
  	set mom_feed_rate $mom_kin_rapid_feed_rate
    }
    return $mom_feed_rate
  } else {
    set mom_warning_info "FEED RATE UNDEFINED" ; MOM_catch_warning ; return 0.0
  }
}


set feed 0.0 ; set feed_mode MMPM

#=============================================================
proc PB_CMD_kin_feedrate_set { } {
#=============================================================
# This procedure supercedes the functionalites provided by the
# FEEDRATE_SET in ugpost_base.tcl.  Post Builder automatically
# generates proper call sequences to this procedure in the
# Event handlers.
#
# This procedure must be used in conjunction with ugpost_base.tcl.
#
  global   feed com_feed_rate
  global   mom_feed_rate_output_mode super_feed_mode feed_mode
  global   mom_cycle_feed_rate_mode mom_cycle_feed_rate
  global   mom_cycle_feed_rate_per_rev
  global   mom_motion_type
  global   mom_warning_info
  global   Feed_IPM Feed_IPR Feed_MMPM Feed_MMPR Feed_INV
  global   mom_sys_feed_param
  global   mom_sys_cycle_feed_mode

  set super_feed_mode $mom_feed_rate_output_mode

  set f_pm [ASK_FEEDRATE_FPM] ; set f_pr [ASK_FEEDRATE_FPR]

  switch $mom_motion_type {

    CYCLE {
      if [info exists mom_sys_cycle_feed_mode] {
         if { $mom_sys_cycle_feed_mode != "Auto" } {
            set mom_cycle_feed_rate_mode $mom_sys_cycle_feed_mode
         }
      }
      if {[hiset mom_cycle_feed_rate_mode]} { set super_feed_mode $mom_cycle_feed_rate_mode }
      if {[hiset mom_cycle_feed_rate]} { set f_pm $mom_cycle_feed_rate }
      if {[hiset mom_cycle_feed_rate_per_rev]} { set f_pr $mom_cycle_feed_rate_per_rev }
    }

    FROM -
    RETRACT -
    RETURN -
    LIFT -
    TRAVERSAL -
    GOHOME  -
    GOHOME_DEFAULT -
    RAPID {
      SUPER_FEED_MODE_SET RAPID
    }

    default {
      if {[EQ_is_zero $f_pm] && [EQ_is_zero $f_pr]} {
        SUPER_FEED_MODE_SET RAPID
      } else {
        SUPER_FEED_MODE_SET CONTOUR
      }
    }
  }

  set feed_mode $super_feed_mode

 # Adjust feedrate format per Post output unit again.
  global mom_kin_output_unit
  if { $mom_kin_output_unit == "IN" } {
     switch $feed_mode {
       MMPM {
         set feed_mode "IPM"
         #CATCH_WARNING "Feedrate mode MMPM changed to IPM"
       }
       MMPR {
         set feed_mode "IPR"
         #CATCH_WARNING "Feedrate mode MMPR changed to IPR"
       }
     }
    #CATCH_WARNING "      - "
    #MOM_abort "\n\n\t      - \n\n"
  } else {
     switch $feed_mode {
       IPM {
         set feed_mode "MMPM"
         #CATCH_WARNING "Feedrate mode IPM changed to MMPM"
       }
       IPR {
         set feed_mode "MMPR"
         #CATCH_WARNING "Feedrate mode IPR changed to MMPR"
       }
     }
  }

 global  mom_path_name

  switch $feed_mode {
    IPM     -
    MMPM    { set feed $f_pm }
    IPR     -
    MMPR    {
    	        CATCH_WARNING "    c   - MMPR. Operation $mom_path_name \nFeedrate mode MMPR changed to MMPM"
    	        set feed $f_pm
    	        set feed_mode "MMPM"
     }
    DPM     {
    	#returns feed rate in degrees per min
    	CATCH_WARNING "    c   - DPM. Operation $mom_path_name "
    	set feed [PB_CMD_FEEDRATE_DPM]
     }
    FRN     -
    INVERSE {
    	# returns feed rate number in inverse time
    	CATCH_WARNING "    c   - FRN , INVERSE . Operation $mom_path_name "
    	set feed [PB_CMD_FEEDRATE_NUMBER]
     }
    default { set mom_warning_info "INVALID FEED RATE MODE" ; MOM_catch_warning ; return }
  }


 # Post Builder provided format for the current mode:
  if [info exists mom_sys_feed_param(${feed_mode},format)] {
    MOM_set_address_format F $mom_sys_feed_param(${feed_mode},format)
  } else {
    switch $feed_mode {
      IPM     -
      MMPM    -
      IPR     -
      MMPR    -
      DPM     -
      FRN     { MOM_set_address_format F Feed_${feed_mode} }
      INVERSE { MOM_set_address_format F Feed_INV }
    }
  }

 # Commentary output
  set com_feed_rate $f_pm


 # Execute user's commnad, if any.
  if [llength [info commands "PB_CMD_FEEDRATE_SET"]] {
     PB_CMD_FEEDRATE_SET
  }
}


#=============================================================
proc CATCH_WARNING { msg } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number

   set level [info level]
   set call_stack ""
   for {set i 1} {$i < $level} {incr i} {
      set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
   }
   set mom_warning_info "$msg ($mom_motion_event $mom_event_number) " ; # $call_stack
   MOM_output_to_listing_device $mom_warning_info
   MOM_catch_warning
}


#=============================================================
proc PB_approach_move { } {
#=============================================================
}

#=============================================================
proc PB_engage_move { } {
#=============================================================
}

#=============================================================
proc PB_first_cut { } {
#=============================================================
}

#=============================================================
proc PB_retract_move { } {
#=============================================================
}

#=============================================================
proc PB_return_move { } {
#=============================================================
}

#=============================================================
proc PB_departure_move { } {
#=============================================================
}

#=============================================================
proc PB_first_linear_move { } {
#=============================================================
}


proc MOM_before_motion {} {
#_______________________________________________________________________________
  global mom_motion_event mom_motion_type  mom_current_motion

  FEEDRATE_SET

    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
      RETURN   {PB_return_move}
      RETRACT  {PB_retract_move}
      DEPARTURE {PB_departure_move}
    }

    if { [llength [info commands PB_CMD_kin_before_motion]] } { PB_CMD_kin_before_motion }
    if { [llength [info commands PB_CMD_before_motion]] }     { PB_CMD_before_motion }

}




#=============================================================
proc PB_CMD_init_turbo_output { } {
#=============================================================
#uplevel #0 {
    #set mom_kin_is_turbo_output             "TRUE"
    #MOM_reload_kinematics
#  }
}


#=============================================================
proc PB_CMD_kin_before_motion { } {
#=============================================================
}


#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================
global mom_pos mom_prev_pos
global mom_current_motion
global mom_nxt_motion_event mom_nxt_mcs_goto

 global g_plane  ;  set g_plane [CHECK_PLANE]

 global dp dpn
 if {![info exists dp]} {
     for { set ii 0 } { $ii<3 } { incr ii } { set dp($ii) 0. ; }
 }
 if {[info exists mom_current_motion]} {
   if {![info exists mom_prev_pos]} {
     for { set ii 0 } { $ii<3 } { incr ii } { set mom_prev_pos($ii) $mom_pos($ii) ; }
   }
   VEC3_sub mom_pos mom_prev_pos dp
 }

 global mom_motion_distance
 global distance
 if {[info exists distance]==0} { set distance 0.0 }
 set distance [ expr $distance + $mom_motion_distance ]

}


#=============================================================
proc PB_CMD_kin_end_of_path { } {
#=============================================================
  # Record tool time for this operation.
   if [llength [info commands PB_CMD_set_oper_tool_time] ] {
      PB_CMD_set_oper_tool_time
   }
}


proc MOM_linear_move {} {
#_______________________________________________________________________________
# This procedure is executed for each linear move. It gets called after
# the positioning varables, position and tool axis (X,Z,TAX,TAY,TAZ) are loaded.
#_______________________________________________________________________________

  global feed_mode mom_feed_rate mom_kin_rapid_feed_rate
  if { $feed_mode == "IPM" || $feed_mode == "MMPM" } {
      if { [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate] } {
         MOM_rapid_move
         return
      }
   }

  global first_linear_move
  if { !$first_linear_move } {
      PB_first_linear_move
      incr first_linear_move
   }

  #global mom_cutcom_mode   mom_cutcom_status
  #if {[info exists mom_cutcom_mode]} {   set mom_cutcom_status $mom_cutcom_mode ; }

  catch { PB_slowdn_move }

   MOM_do_template linear_move

}


proc MOM_circular_move {} {
#_______________________________________________________________________________
# This procedure is executed for each circular move. It gets called after
# the circle data are loaded (end point and center).
#_______________________________________________________________________________
  global mom_pos_arc_axis  mom_arc_radius
  global mom_pos  mom_prev_pos
  global mom_path_name
  global mom_motion_distance mom_kin_arc_output_mode

  CIRCLE_SET

  #global mom_cutcom_mode   mom_cutcom_status
  #if {[info exists mom_cutcom_mode]} { set mom_cutcom_status $mom_cutcom_mode }

  catch { PB_slowdn_move }

  global g_plane

  switch $g_plane {
     "17" {
          MOM_suppress once K ; MOM_force always  I J
          set tmp0 [expr abs($mom_pos(0)-$mom_prev_pos(0)) ]
          set tmp1 [expr abs($mom_pos(1)-$mom_prev_pos(1)) ]
          global PI
          set f [ expr (2.0*$PI*$mom_arc_radius) ]
          set tmp [expr abs($f-$mom_motion_distance) ]
          #  MOM_output_literal "fff=$mom_motion_distance f=$f "
          if {$tmp0<0.015 && $tmp1<0.015} {
             if {[EQ_is_gt $tmp 0.0000001]} {
               if {[EQ_is_gt $tmp 0.1]} { MOM_linear_move ; return ;  }
              }
           }
           #  MOM_do_template plane

           global mom_output_circular_radius
           if {[info exists mom_output_circular_radius]==0} { set mom_output_circular_radius "OFF" ; }

           if {$mom_output_circular_radius=="ON"} {
              ;#
              SET_SIGN_OF_RADIUS
              MOM_force once Radius
              MOM_do_template circular_move_radius
              ;#
             } else {
              ;#
              MOM_do_template circular_move
              ;#
           }

        }
     "18"
        {
          MOM_suppress once J
          MOM_output_to_listing_device "WARNING: Path :- $mom_path_name"
          MOM_output_to_listing_device "WARNING: Cannot do circles in G18 plane"

 set mom_kin_arc_output_mode  "LINEAR"  ;   #QUADRANT  FULL_CIRCLE , LINEAR

          MOM_reload_kinematics
MOM_do_template linear
        }
     "19"
        {
          MOM_output_to_listing_device "WARNING: Path :- $mom_path_name"
          MOM_output_to_listing_device "WARNING: Cannot do circles in G19 plane"
 set mom_kin_arc_output_mode  "LINEAR"  ;   #QUADRANT  FULL_CIRCLE , LINEAR


          MOM_reload_kinematics
MOM_do_template linear
        }
  }

}

#=============================================================
proc SET_SIGN_OF_RADIUS {} {
#=============================================================
  global mom_arc_radius
  global mom_arc_angle

  if {$mom_arc_angle > 180.000000} {
      set mom_arc_radius [expr ( -1.0 * $mom_arc_radius ) ]
  } else {
      set mom_arc_radius [expr abs($mom_arc_radius)]
  }
}


proc MOM_rapid_move {} {
#_______________________________________________________________________________
# This procedure is executed for each rapid move. It gets called after
# the positioning varables, position and tool axis (X,Z,TAX,TAY,TAZ) are loaded.
#_______________________________________________________________________________
  global mom_motion_type

  RAPID_SET

#  global mom_coolant_mode  mom_coolant_status
#  if {[info exists mom_coolant_mode]} {  set mom_coolant_status $mom_coolant_mode  }

  catch { PB_slowdn_move }

  MOM_do_template rapid_xy
  MOM_do_template rapid_z

}


####################################--#########################################

set cycle_step 0

proc cycle_set {} {
#_______________________________________________________________________________
# This procedure is executed for each new cycle.  This will make sure all
# non-modal addresses and Cycle parameters are output that need to be output
# at the start of a new cycle.
#_______________________________________________________________________________
  global mom_cycle_retract_mode
  global g_return

  MOM_force once G_motion X Z R cycle_dwell cycle_nodrag cycle_step

  switch $mom_cycle_retract_mode {
  	AUTO { set g_return 98 ; }
  	default { set g_return 99 ; }
  }

}

proc MOM_cycle_plane_change {} {
#_______________________________________________________________________________
# This procedure is executed at the end of cycle motion when there is a cycle
# move occuring at a higher level than the previous position.
#_______________________________________________________________________________
  global cycle_init_flag ;   set cycle_init_flag TRUE

  MOM_do_template cycle_plane_change_z
  MOM_do_template cycle_plane_change_xy

}

proc MOM_cycle_off {} {
#_______________________________________________________________________________
# This procedure is executed at the end of cycle motion.
#_______________________________________________________________________________
  global   cycle_step ; set  cycle_step 0 ;
  MOM_do_template cycle_off
}

proc MOM_drill_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a drill cycle.
#_______________________________________________________________________________
  global cycle_init_flag ;
  MOM_do_template cycle_drill
  set cycle_init_flag FALSE
}

proc MOM_drill_dwell {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a drill dwell cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name DRILL_DWELL
  set cycle_init_flag TRUE
	cycle_set
}

proc MOM_drill_dwell_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a drill dwell cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_do_template cycle_drill_dwell
  set cycle_init_flag FALSE
}

proc MOM_drill_counter_sink {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a drill cycle.
#_______________________________________________________________________________
         MOM_drill
}

proc MOM_drill_counter_sink_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a drill cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_drill_move
  set cycle_init_flag FALSE
}

proc MOM_drill_csink_dwell {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a drill dwell cycle.
#_______________________________________________________________________________
	 MOM_drill_dwell
}

proc MOM_drill_csink_dwell_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a drill dwell cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_drill_dwell_move
  set cycle_init_flag FALSE
}

proc MOM_drill_deep {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a deep cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name DRILL_DEEP
  set cycle_init_flag TRUE
	 cycle_set
}

proc MOM_drill_deep_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a  deep cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_do_template cycle_drill_deep
  set cycle_init_flag FALSE
}

proc MOM_drill_break_chip {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a brkchp cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name DRILL_BREAK_CHIP
  set cycle_init_flag TRUE
       	 cycle_set
}

proc MOM_drill_break_chip_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a  brkchp cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_do_template cycle_breakchip
  set cycle_init_flag FALSE
}

proc MOM_tap {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a tap cycle.
#_______________________________________________________________________________
  global cycle_name  ;     set cycle_name TAP
  global cycle_init_flag ;  set cycle_init_flag TRUE
  MOM_output_text "; TAP: F (/) =   (/) *  S (/) "
 	 cycle_set
}

proc MOM_tap_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a tap cycle.
#_______________________________________________________________________________
  global cycle_init_flag

  global mom_sys_cycle_tap_right_code mom_sys_cycle_tap_left_code
  global mom_sys_cycle_tap_code

  global mom_spindle_direction
  if {$mom_spindle_direction == "CCLW"} {
      set mom_sys_cycle_tap_code $mom_sys_cycle_tap_left_code
  } else {
      set mom_sys_cycle_tap_code $mom_sys_cycle_tap_right_code
  }
  MOM_do_template cycle_tap
  set cycle_init_flag FALSE
}

proc MOM_bore {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a bore cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name BORE
  set cycle_init_flag TRUE
	 cycle_set
}

proc MOM_bore_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a bore cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_do_template cycle_bore
  set cycle_init_flag FALSE
}

proc MOM_bore_dwell {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a bore cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name BORE_DWELL
  set cycle_init_flag TRUE
	 cycle_set
}

proc MOM_bore_dwell_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a bore dwell cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_do_template cycle_bore_dwell
  set cycle_init_flag FALSE
}

proc MOM_bore_drag {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a bore drag cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name BORE_DRAG
  set cycle_init_flag TRUE
	 cycle_set
}

proc MOM_bore_drag_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a bore_drag cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_do_template cycle_bore_drag
  set cycle_init_flag FALSE
}

proc MOM_bore_no_drag {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a bore nodrag cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name BORE_NO_DRAG
  set cycle_init_flag TRUE
	 cycle_set
}

proc MOM_bore_no_drag_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a bore nodrag cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_do_template cycle_bore_no_drag
  set cycle_init_flag FALSE
}

proc MOM_bore_back {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a bore back cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name BORE_BACK
  set cycle_init_flag TRUE
	 cycle_set
}

proc MOM_bore_back_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a back bore cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_do_template cycle_bore_back
  set cycle_init_flag FALSE
}

proc MOM_bore_manual {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a bore manual cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name BORE_MANUAL
  set cycle_init_flag TRUE
	 cycle_set
  global mom_warning_info
  set mom_warning_info "WARNING:    \[bore_manual\]    \n     Point-to-Point"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

proc MOM_bore_manual_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a manual bore cycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_linear_move
  set cycle_init_flag FALSE
}

proc MOM_bore_manual_dwell {} {
#_______________________________________________________________________________
# This procedure is executed at the begining of a bore manual dwell bore cycle.
#_______________________________________________________________________________
  global cycle_name
  global cycle_init_flag
  set cycle_name BORE_MANUAL_DWELL
  set cycle_init_flag TRUE
	 cycle_set
  global mom_warning_info
  set mom_warning_info "WARNING:      \[bore_manual_dwell\]    \n     Point-to-Point"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

proc MOM_bore_manual_dwell_move {} {
#_______________________________________________________________________________
# This procedure is executed for the goto of a manual dwell borecycle.
#_______________________________________________________________________________
  global cycle_init_flag
  MOM_linear_move
  set cycle_init_flag FALSE
}

#################################################################################

proc MOM_sequence_number {} {
#_______________________________________________________________________________
# This procedure is executed for the Sequence Number command.
#_______________________________________________________________________________
     SEQNO_SET
}

proc MOM_set_modes {} {
#_______________________________________________________________________________
# This procedure is executed for the Set Mode command.
#_______________________________________________________________________________
  global mom_output_mode
  global mom_arc_mode
  global mom_feed_rate_output_mode
  global mom_parallel_to_axis
  global mom_machine_mode
  global mom_modes_text
  global mom_warning_info

# "ABSOLUTE", "INCREMENTAL"
  if {$mom_output_mode == "ABSOLUTE"} {
      MOM_incremental OFF X Z Y
      MOM_force once G_mode
  } elseif {$mom_output_mode == "INCREMENTAL"} {
      MOM_incremental ON X Z Y
      MOM_force once G_mode
  }

# "LINEAR", "CIRCULAR"

  if {$mom_arc_mode == "LINEAR"} {
  } elseif {$mom_arc_mode == "CIRCULAR"} {
  }

# "OFF", "IPM", "IPR", "MMPM", "MMPR", "INVERSE"

  if {$mom_feed_rate_output_mode == "FPM"} {
  } elseif {$mom_feed_rate_output_mode == "FPR"} {
  } elseif {$mom_feed_rate_output_mode == "INVERSE"} {
  } elseif {$mom_feed_rate_output_mode == "OFF"} {
  }

# "ZAXIS", "WAXIS", "UAXIS"
  switch $mom_parallel_to_axis {
    ZAXIS { ; }
    default  {
       set mom_warning_info "WARNING:     Z (    Z)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set mom_parallel_to_axis  "ZAXIS"
     }
  }

# "MILL", "TURN", "PUNCH", "LASER", "TORCH", "WIRE"
  switch $mom_machine_mode {
    MILL { ; }
    default  {
       set mom_warning_info "WARNING:        2.5 (    MILL)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set  mom_machine_mode  "MILL"
     }
  }

}


proc MOM_cutcom_on {} {
#_______________________________________________________________________________
# This procedure is executed when the Cutcom command is activated.
#_______________________________________________________________________________
  global mom_cutcom_status   mom_cutcom_mode
  global mom_cutcom_adjust_register
  global mom_tool_adjust_register

  global g_plane ; set g_plane [CHECK_PLANE] ;
  MOM_do_template plane

  CUTCOM_SET

  if {[info exists mom_cutcom_mode]} { set mom_cutcom_status $mom_cutcom_mode  }
  if {[info exists mom_cutcom_adjust_register]==0} { set mom_cutcom_adjust_register 0 ;  }
  #if {$mom_cutcom_adjust_register == 0} { MOM_abort "      0 " ; }
  if {[info exists mom_tool_adjust_register]==0} { set mom_tool_adjust_register 0 ;  }
  #MOM_suppress always D_cutcom
  catch {unset mom_cutcom_mode}

}


proc MOM_cutcom_off {} {
#_______________________________________________________________________________
# This procedure is executed when the Cutcom command is deactivated.
#_______________________________________________________________________________
  global mom_cutcom_status mom_cutcom_mode
  CUTCOM_SET
  catch {unset mom_cutcom_mode}
  MOM_do_template cutcom_off
}


#=============================================================
proc PB_select_range_spindle { } {
#=============================================================
 global  mom_spindle_rpm  mom_spindle_speed  mom_spindle_sfm
 global  mom_spindle_range
 global  mom_spindle_mode
 global  mom_sys_spindle_param   mom_sys_spindle_ranges

 global speed range

 set s $mom_spindle_speed ;  set range 41

 if {[info exists mom_spindle_rpm] && $mom_spindle_rpm > 0.0} {
    set s $mom_spindle_rpm
  }

 if {![info exists mom_spindle_range]} { set mom_spindle_range 1 ; }
 if [catch {expr {2 * $mom_spindle_range}}] { set mom_spindle_range 1 ; }

 switch $mom_spindle_range {
  0 { set mom_spindle_range 1 ; }
  41 { set mom_spindle_range 1 ; }
  42 { set mom_spindle_range 2 ; }
  43 { set mom_spindle_range 3 ; }
  44 { set mom_spindle_range 4 ; }
  45 { set mom_spindle_range 5 ; }
  46 { set mom_spindle_range 6 ; }
  default { ; }
 }

 set range [ expr $mom_spindle_range + 40 ]

}


proc MOM_spindle_rpm {} {
#_______________________________________________________________________________
# This procedure is executed when the Spindle command is activated.
#_______________________________________________________________________________
  global mom_spindle_speed
  global mom_spindle_range
  if {$mom_spindle_range==""} { set mom_spindle_range 0 }

  SPINDLE_SET

  catch { PB_select_range_spindle }

  MOM_do_template spindle_start
  MOM_do_template spindle_direction
}


#=============================================================
proc MOM_spindle_css { } {
#=============================================================
# This procedure is executed when the Spindle command is activated SFM/SMM mode.
  global mom_spindle_status mom_spindle_mode
  set mom_spindle_status $mom_spindle_mode

  if {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} {
     SPINDLE_SET
  }

  MOM_spindle_rpm

}

#=============================================================
proc MOM_spindle_off { } {
#=============================================================
   MOM_do_template spindle_off
}


proc MOM_coolant_on {} {
#_______________________________________________________________________________
# This procedure is executed when the Coolant command is activated.
#_______________________________________________________________________________
 global mom_coolant_status  mom_coolant_mode
 if {![info exists mom_coolant_mode]} { set mom_coolant_mode ON }
 set mom_coolant_status $mom_coolant_mode
 MOM_do_template coolant_on
}

proc MOM_coolant_off {} {
#_______________________________________________________________________________
# This procedure is executed when the Coolant command is deactivated.
#_______________________________________________________________________________
  MOM_do_template coolant_off
}

proc MOM_opstop {} {
#_______________________________________________________________________________
# This procedure is executed when the Optional Stop command is activated.
#_______________________________________________________________________________
  MOM_do_template opstop
}

proc MOM_operator_message {} {
#_______________________________________________________________________________
# This procedure is executed when the Operator Message command is activated.
#_______________________________________________________________________________
  global mom_operator_message

  if {[info exists mom_operator_message]} {
    if {$mom_operator_message==""} { set mom_operator_message "...." ; }
    MOM_output_literal "(DIS,'$mom_operator_message')"
  }
}

proc MOM_stop {} {
#_______________________________________________________________________________
# This procedure is executed when the Program Stop command is activated.
#_______________________________________________________________________________
         MOM_do_template stop
}

proc MOM_delay {} {
#_______________________________________________________________________________
# This procedure is executed when the Delay command is activated.
#_______________________________________________________________________________
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time
  global mom_warning_info

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {
         set delay_time $mom_delay_revs ;
         set mom_warning_info "WARNING:      . !"
         MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
      }
    }

#  if {$delay_time<0.0} { set delay_time 0.0 }
#  if {$delay_time>255.0} { set delay_time 255.0 }
#  set delay_time [ format "%.0f" $delay_time ]
#  MOM_output_literal "(TMR, $delay_time )"

  MOM_do_template  delayTMR
  MOM_do_template  delay

}

proc MOM_auxfun {} {
#_______________________________________________________________________________
# This procedure is executed when the Auxiliary command is activated.
#_______________________________________________________________________________
  MOM_do_template auxiliary
}

proc MOM_prefun {} {
#_______________________________________________________________________________
# This procedure is executed when the Preparatory function command is activated.
#_______________________________________________________________________________
  MOM_do_template preparatory
}

proc MOM_length_compensation {} {
#_______________________________________________________________________________
# This procedure is executed when the Tool Length Compensation command is activated.
#_______________________________________________________________________________
  global mom_length_comp_register
  TOOL_SET MOM_length_compensation
  MOM_force once G_motion G Z T M
  catch { MOM_do_template tool_length_adjust } errMes ; MOM_log_message $errMes
#  global mom_warning_info
#  set mom_warning_info "WARNING:      ''   \[ length_compensation\]"
#  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

proc MOM_tool_preselect {} {
#_______________________________________________________________________________
# This procedure is executed when the Tool Preselect command is activated.
#_______________________________________________________________________________
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
  global mom_warning_info ;
  set mom_warning_info  "WARNING:     ''   \[ tool_preselect\]"
  MOM_output_to_listing_device $mom_warning_info ; MOM_catch_warning ;
}

#=============================================================
proc MOM_origin {} {
#=============================================================
  global mom_origin_point ;
  global mom_warning_info ;
  set mom_warning_info "WARNING:   X, Y, Z -  "
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

#=============================================================
proc  MOM_pprint {} {
#=============================================================
#___ This procedure is executed when the Text command is activated.
 global mom_pprint ;
 MOM_set_seq_off
 MOM_output_literal  "; $mom_pprint"
 MOM_set_seq_on
}

proc MOM_text {} {
#_______________________________________________________________________________
# This procedure is executed when the Text command is activated.
#_______________________________________________________________________________
  global mom_user_defined_text mom_record_fields
  global mom_field_count
  global mom_sys_control_out mom_sys_control_in
  global mom_record_text mom_pprint mom_Instruction mom_operator_message
  global mom_pprint_defined mom_operator_message_defined
  global mom_warning_info

  switch [string toupper $mom_record_fields(0)] {
  "CUTCOM"  {
		if {$mom_record_fields(1) == "LEFT"} {
			MOM_output_literal "G41"
		} elseif {$mom_record_fields(1) == "RIGHT"} {
			MOM_output_literal "G42"
		} elseif {$mom_record_fields(1) == "OFF"} {
			MOM_output_literal "G40"
		}
         }
  "SET" { ; }
  "PPRINT" {
           set mom_pprint_defined 1
           set mom_pprint $mom_record_text
           MOM_pprint
           }
  "DISPLY" {
           set mom_operator_message_defined 1
           set mom_operator_message $mom_record_text
           MOM_operator_message
          }
  "INSERT" {
           if {[info exists mom_record_fields(1)]}  {
              set mom_Instruction [string toupper $mom_record_text ] ; #$mom_record_fields(1)] ;
              MOM_insert
              set mom_warning_info "WARNING:    'INSERT/$mom_Instruction' -  "
              MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;
           }
         }
  "ZERO" {
          global mom_work_coordinate_number
          set mom_work_coordinate_number $mom_record_fields(1)
          MOM_zero
         }
 "MIRROR" {  ; #  
  	    global mom_trans_output_mode
  	    global mom_kin_is_turbo_output
  	    if {[info exists mom_kin_is_turbo_output]}  {
  	    	if {"$mom_kin_is_turbo_output"=="TRUE"} { set mom_trans_output_mode 0 ; }
  	    }
	    catch { PB_mirror }
        }
  "SLOWDN" {  ; #    
  		catch { PB_slowdn }
          }
 "SAFETY" { ; #       
         }
  "TIME" { ; }
 default {
            set mom_warning_info "WARNING:   !($mom_user_defined_text)\n"
            MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;
            MOM_output_literal $mom_user_defined_text
         }
  }
}


#=============================================================
proc  MOM_zero {} {
#=============================================================
#     G      .
#         Fanuc.
#   G   ZERO/CHECK, ZERO/ON, ZERO/OFF, ZERO/THRU,   G   ZERO/n.
#
  global mom_sys_wcs_change_code mom_work_coordinate_number
  if {[info exists mom_work_coordinate_number]==0} { set mom_work_coordinate_number 0 ; }
  if {$mom_work_coordinate_number==""} { set mom_work_coordinate_number 0 }
  MOM_output_literal "(UAO,$mom_work_coordinate_number)"

}


#==================================================================
proc MOM_path_warning { } {
#==================================================================
# This procedure is executed when the in CLSF file has Inconsistent axis.
  global mom_path_warning
  if {[info exists mom_path_warning]} {
     if {[string length $mom_path_warning]!=0} {
     	global mom_seqnum mom_warning_info
     	set tmpNum 0 ; catch { set tmpNum [format "%.0f" $mom_seqnum] }
        set mom_warning_info "!! : $mom_path_warning ( =$tmpNum)"
     	MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     	; # MOM_abort $mom_warning_info
     	}
   }

}


#=============================================================
proc  MOM_before_output {} {
#=============================================================
# This procedure is executed just before a line is about to be output
# to the file. It loads the line into a variable MOM_o_buffer and then calls
# this procedure. When it returns from this procedure, the variable MOM_o_buffer
# is read and written to the file.
#=============================================================
#########The following procedure invokes the listing file with warnings.
         LIST_FILE
# If the variable buffer_action is set to one then every string that comes
# through here will be buffered into an array of strings "buffer" and the
# mom_o_buffer is reset to an empty string so that no output is done.

 global MOM_o_buffer
 global mom_o_buffer

}

#------------------------------------------------------------------------------
# Local Procedures for use in this post
#------------------------------------------------------------------------------

proc CHECK_PLANE {} {

  global mom_tool_axis
  global mom_path_name

  global prev_error_path

#-------- Decision on plane of operation

  if {[EQ_is_equal $mom_tool_axis(1) 1.0]} {
      set g_plane 18
  } elseif {[EQ_is_equal $mom_tool_axis(2) 0.0]} {
      set g_plane 19
  } elseif {[EQ_is_equal $mom_tool_axis(2) 1.0]} {
      set g_plane 17
  } elseif {([EQ_is_gt $mom_tool_axis(2) 0.0] && \
                 [EQ_is_lt $mom_tool_axis(2) 1.0]) || \
             [EQ_is_lt $mom_tool_axis(2) 0.0] } {
      set g_plane "NONE"

      set i [format "%-.7f" $mom_tool_axis(0)]
      set j [format "%-.7f" $mom_tool_axis(1)]
      set k [format "%-.7f" $mom_tool_axis(2)]

      # Check to output this error only once per path

      if {[info exists prev_error_path]} {
            if {$prev_error_path == $mom_path_name} { return $g_plane }
      }
      MOM_output_to_listing_device \
      "ERROR! PATH - $mom_path_name has invalid tool axis vector ($i,$j,$k)"
      MOM_output_to_listing_device \
      "3-axis Mill machine cannot position the tool to this orientation"
      MOM_output_to_listing_device \
      "The output will be incorrect!!"

      set prev_error_path $mom_path_name
  } else {
      set g_plane 18
  }

  return $g_plane
}



################################################################################

#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}alpha_users.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }
